package io.gitlab.jfronny.commons.data.dynamic;

import io.gitlab.jfronny.commons.StringFormatter;

public interface Dynamic<T> {
    T getValue();

    default DBool asBool() {
        if (this instanceof DBool bool) return bool;
        else throw new DynamicTypeConversionException("bool");
    }

    default DNumber asNumber() {
        if (this instanceof DNumber number) return number;
        else throw new DynamicTypeConversionException("number");
    }

    default DString asString() {
        if (this instanceof DString string) return string;
        else return DFinal.of(StringFormatter.toString(getValue()));
    }

    default DObject asObject() {
        if (this instanceof DObject object) return object;
        else throw new DynamicTypeConversionException("object");
    }

    default DList asList() {
        if (this instanceof DList list) return list;
        else throw new DynamicTypeConversionException("list");
    }

    default DCallable asCallable() {
        if (this instanceof DCallable callable) return callable;
        else throw new DynamicTypeConversionException("callable");
    }
}
