package io.gitlab.jfronny.muscript.compiler.expr;

import io.gitlab.jfronny.commons.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.compiler.Type;
import io.gitlab.jfronny.muscript.compiler.expr.dynamic.unpack.*;

public abstract non-sealed class DynamicExpr extends Expr<Dynamic<?>> {
    public DynamicExpr(int character) {
        super(character);
    }

    @Override
    public Type getResultType() {
        return Type.Dynamic;
    }

    @Override
    public abstract DynamicExpr optimize();

    @Override
    public BoolExpr asBoolExpr() {
        return new BoolUnpack(character, this);
    }

    @Override
    public StringExpr asStringExpr() {
        return new StringUnpack(character, this);
    }

    @Override
    public NumberExpr asNumberExpr() {
        return new NumberUnpack(character, this);
    }

    @Override
    public DynamicExpr asDynamicExpr() {
        return this;
    }
}
