package io.gitlab.jfronny.muscript.compiler.expr.bool;

import io.gitlab.jfronny.commons.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.compiler.expr.BoolExpr;
import io.gitlab.jfronny.muscript.compiler.expr.Expr;
import io.gitlab.jfronny.muscript.compiler.expr.common.literal.BoolLiteral;

public class Not extends BoolExpr {
    private final BoolExpr inner;

    public Not(int character, BoolExpr inner) {
        super(character);
        this.inner = inner;
    }

    @Override
    public Boolean get(Dynamic<?> dataRoot) {
        return !inner.get(dataRoot);
    }

    @Override
    public BoolExpr optimize() {
        BoolExpr inner = this.inner.optimize();
        if (inner instanceof Not not) return not.inner;
        if (inner instanceof BoolLiteral literal) return Expr.literal(character, !literal.value);
        return new Not(character, inner);
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof Not not && inner.equals(not.inner);
    }
}
