package io.gitlab.jfronny.muscript.compiler.expr.common.literal;

import io.gitlab.jfronny.commons.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.compiler.expr.BoolExpr;

public final class BoolLiteral extends BoolExpr {
    public final boolean value;

    public BoolLiteral(int character, boolean value) {
        super(character);
        this.value = value;
    }

    @Override
    public Boolean get(Dynamic<?> dataRoot) {
        return value;
    }

    @Override
    public BoolExpr optimize() {
        return this;
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof BoolLiteral literal && value == literal.value;
    }
}
