package io.gitlab.jfronny.muscript.compiler.expr.common.literal;

import io.gitlab.jfronny.commons.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.compiler.expr.DynamicExpr;

public final class DynamicLiteral<T> extends DynamicExpr {
    public final Dynamic<T> value;

    public DynamicLiteral(int character, Dynamic<T> value) {
        super(character);
        this.value = value;
    }

    @Override
    public Dynamic<T> get(Dynamic<?> dataRoot) {
        return value;
    }

    @Override
    public DynamicExpr optimize() {
        return this;
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof DynamicLiteral<?> literal && value.equals(literal.value);
    }
}
