package io.gitlab.jfronny.muscript.compiler.expr.common.literal;

import io.gitlab.jfronny.commons.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.compiler.expr.NumberExpr;

public final class NumberLiteral extends NumberExpr {
    public final double value;

    public NumberLiteral(int character, double value) {
        super(character);
        this.value = value;
    }

    @Override
    public Double get(Dynamic<?> dataRoot) {
        return value;
    }

    @Override
    public NumberExpr optimize() {
        return this;
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof NumberLiteral literal && value == literal.value;
    }
}
