package io.gitlab.jfronny.muscript.compiler.expr.common.literal;

import io.gitlab.jfronny.commons.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.compiler.expr.StringExpr;

public final class StringLiteral extends StringExpr {
    public final String value;

    public StringLiteral(int character, String value) {
        super(character);
        this.value = value;
    }

    @Override
    public String get(Dynamic<?> dataRoot) {
        return value;
    }

    @Override
    public StringExpr optimize() {
        return this;
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof StringLiteral literal && value.equals(literal.value);
    }
}
