package io.gitlab.jfronny.muscript.compiler.expr.dynamic.unpack;

import io.gitlab.jfronny.commons.data.dynamic.*;
import io.gitlab.jfronny.muscript.compiler.expr.*;
import io.gitlab.jfronny.muscript.compiler.expr.annotations.*;
import io.gitlab.jfronny.muscript.compiler.expr.dynamic.DynamicCoerce;

@CanThrow
@UncheckedDynamic
public class BoolUnpack extends BoolExpr {
    public final DynamicExpr inner;

    public BoolUnpack(int character, DynamicExpr inner) {
        super(character);
        this.inner = inner;
    }

    @Override
    public Boolean get(Dynamic<?> dataRoot) {
        try {
            return inner.get(dataRoot).asBool().getValue();
        } catch (DynamicTypeConversionException e) {
            throw e.locational(character);
        }
    }

    @Override
    public BoolExpr optimize() {
        DynamicExpr inner = this.inner.optimize();
        if (inner instanceof DynamicCoerce coerce) return coerce.inner.asBoolExpr();
        return new BoolUnpack(character, inner);
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof BoolUnpack unpack && inner.equals(unpack.inner);
    }
}
