package io.gitlab.jfronny.muscript.compiler.expr.dynamic.unpack;

import io.gitlab.jfronny.commons.data.dynamic.Dynamic;
import io.gitlab.jfronny.commons.data.dynamic.DynamicTypeConversionException;
import io.gitlab.jfronny.muscript.compiler.expr.DynamicExpr;
import io.gitlab.jfronny.muscript.compiler.expr.NumberExpr;
import io.gitlab.jfronny.muscript.compiler.expr.annotations.*;
import io.gitlab.jfronny.muscript.compiler.expr.dynamic.DynamicCoerce;

@CanThrow
@UncheckedDynamic
public class NumberUnpack extends NumberExpr {
    public final DynamicExpr inner;

    public NumberUnpack(int character, DynamicExpr inner) {
        super(character);
        this.inner = inner;
    }

    @Override
    public Double get(Dynamic<?> dataRoot) {
        try {
            return inner.get(dataRoot).asNumber().getValue();
        } catch (DynamicTypeConversionException e) {
            throw e.locational(character);
        }
    }

    @Override
    public NumberExpr optimize() {
        DynamicExpr inner = this.inner.optimize();
        if (inner instanceof DynamicCoerce coerce) return coerce.inner.asNumberExpr();
        return new NumberUnpack(character, inner.optimize());
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof NumberUnpack unpack && inner.equals(unpack.inner);
    }
}
