package io.gitlab.jfronny.muscript.compiler.expr.number.math;

import io.gitlab.jfronny.commons.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.compiler.expr.Expr;
import io.gitlab.jfronny.muscript.compiler.expr.NumberExpr;
import io.gitlab.jfronny.muscript.compiler.expr.common.literal.NumberLiteral;

public class Invert extends NumberExpr {
    public final NumberExpr inner;

    public Invert(int character, NumberExpr inner) {
        super(character);
        this.inner = inner;
    }

    @Override
    public Double get(Dynamic<?> dataRoot) {
        return -inner.get(dataRoot);
    }

    @Override
    public NumberExpr optimize() {
        NumberExpr inner = this.inner.optimize();
        if (inner instanceof Invert invert) return invert.inner;
        if (inner instanceof NumberLiteral literal) return Expr.literal(character, -literal.value);
        return new Invert(character, inner);
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof Invert invert && inner.equals(invert.inner);
    }
}
