package io.gitlab.jfronny.muscript.compiler.expr.number.math;

import io.gitlab.jfronny.commons.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.compiler.expr.Expr;
import io.gitlab.jfronny.muscript.compiler.expr.NumberExpr;
import io.gitlab.jfronny.muscript.compiler.expr.common.literal.NumberLiteral;

public class Plus extends NumberExpr {
    public final NumberExpr augend;
    public final NumberExpr addend;

    public Plus(int character, NumberExpr augend, NumberExpr addend) {
        super(character);
        this.augend = augend;
        this.addend = addend;
    }

    @Override
    public Double get(Dynamic<?> dataRoot) {
        return augend.get(dataRoot) + addend.get(dataRoot);
    }

    @Override
    public NumberExpr optimize() {
        NumberExpr augend = this.augend.optimize();
        NumberExpr addend = this.addend.optimize();
        if (augend instanceof NumberLiteral litU && addend instanceof NumberLiteral litD) return Expr.literal(character, litU.value + litD.value);
        return new Plus(character, augend, addend);
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof Plus plus && augend.equals(plus.augend) && addend.equals(plus.addend);
    }
}
