package io.gitlab.jfronny.muscript.error;

/**
 * An exception type with a location
 * For use in MuScript, can be converted to a pretty LocationalError with asPrintable
 */
public class LocationalException extends RuntimeException {
    private final int location;

    public LocationalException(int location) {
        super();
        this.location = location;
    }

    public LocationalException(int location, String message) {
        super(message);
        this.location = location;
    }

    public LocationalException(int location, String message, Throwable cause) {
        super(message, cause);
        this.location = location;
    }

    public LocationalException(int location, Throwable cause) {
        super(cause);
        this.location = location;
    }

    public LocationalError asPrintable(String source) {
        return LocationalError.create(source, location, getLocalizedMessage());
    }
}
