package io.gitlab.jfronny.muscript.error;

import io.gitlab.jfronny.muscript.compiler.*;
import org.jetbrains.annotations.*;

/**
 * An exception that expresses an unexpected type
 * To be used in expressions
 */
public class TypeMismatchException extends LocationalException {
    private final Type expected;
    private final @Nullable Type actual;

    public TypeMismatchException(int character, Type expected, @Nullable Type actual) {
        this(character, expected, actual, "Expected " + expected + (actual == null ? "" : " but got " + actual));
    }

    public TypeMismatchException(int character, Type expected, @Nullable Type actual, String message) {
        super(character, message);
        this.expected = expected;
        this.actual = actual;
    }
}
