package io.gitlab.jfronny.muscript.test;

import io.gitlab.jfronny.muscript.compiler.*;
import org.junit.jupiter.api.*;

import static org.junit.jupiter.api.Assertions.*;

public class LocationalErrorTest {
    @Test
    void invalidCode() {
        assertEquals("""
                Error at 't' (character 6): Expected Number but got Boolean
                     1 | 15 + true
                              ^-- Here""",
                assertThrows(Parser.ParseException.class, () -> Parser.parse("15 + true")).error.toString());
        assertEquals("""
                Error at ''' (character 6): Expected Number but got String
                     1 | 15 + 'yes'
                              ^-- Here""",
                assertThrows(Parser.ParseException.class, () -> Parser.parse("15 + 'yes'")).error.toString());
        assertEquals("""
                Error at '=' (character 8): Unexpected character
                     1 | string = 'Value'
                                ^-- Here""",
                assertThrows(Parser.ParseException.class, () -> Parser.parse("string = 'Value'")).error.toString());
    }
}
